/**
 * @name eslint-plugin-row-num
 * @fileoverview ESLint plugin to update row numbers on each console.log
 * @version 4.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/eslint-plugin-row-num/}
 */
"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);
// src/main.ts
var main_exports = {};
__export(main_exports, {
  default: () => main_default
});
// ../string-collapse-leading-whitespace/dist/string-collapse-leading-whitespace.esm.js
function D(n, u2 = 1) {
  let $2 = "\xA0";
  function g2(e) {
    return Array.from(e).reverse().join("");
  }
  function p2(e, s, r) {
    let t = r ? `
` : "\r", i = r ? "\r" : `
`;
    if (!e)
      return e;
    let m2 = 0, c = 0, o = "";
    for (let l = 0, f2 = e.length; l < f2; l++)
      (e[l] === t || e[l] === i && e[l - 1] !== t) && c++, `\r
`.includes(e[l]) || e[l] === $2 ? (m2 = 0, e[l] === $2 ? o += e[l] : e[l] === t ? c <= s && (o += e[l], e[l + 1] === i && (o += e[l + 1], l++)) : e[l] === i && e?.[l - 1] !== t && c <= s && (o += e[l])) : (m2++, !e[l + 1] && !c && (o += " "));
    return o;
  }
  if (typeof n == "string" && n.length) {
    let e = 1;
    typeof +u2 == "number" && Number.isInteger(+u2) && +u2 >= 0 && (e = +u2);
    let s = "", r = "";
    if (!n.trim())
      s = n;
    else if (!n[0].trim()) {
      for (let t = 0, i = n.length; t < i; t++)
        if (n[t].trim()) {
          s = n.slice(0, t);
          break;
        }
    }
    if (n.trim() && (n.slice(-1).trim() === "" || n.slice(-1) === $2)) {
      for (let t = n.length; t--; )
        if (n[t].trim()) {
          r = n.slice(t + 1);
          break;
        }
    }
    return `${p2(s, e, false)}${n.trim()}${g2(p2(g2(r), e, true))}`;
  }
  return n;
}
// ../ranges-push/dist/ranges-push.esm.js
var b = { strictlyTwoElementsInRangeArrays: false, progressFn: null };
function h(i, r) {
  if (!Array.isArray(i) || !i.length)
    return i;
  let t = { ...b, ...r }, e, a;
  if (t.strictlyTwoElementsInRangeArrays && !i.every((o, g2) => !Array.isArray(o) || o.length !== 2 ? (e = g2, a = o.length, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${e}th range (${JSON.stringify(i[e], null, 4)}) has not two but ${a} elements!`);
  if (!i.every((o, g2) => !Array.isArray(o) || !Number.isInteger(o[0]) || o[0] < 0 || !Number.isInteger(o[1]) || o[1] < 0 ? (e = g2, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${e}th range (${JSON.stringify(i[e], null, 4)}) does not consist of only natural numbers!`);
  let n = i.length ** 2, l = 0;
  return Array.from(i).sort((o, g2) => (t.progressFn && (l += 1, t.progressFn(Math.floor(l * 100 / n))), o[0] === g2[0] ? o[1] < g2[1] ? -1 : o[1] > g2[1] ? 1 : 0 : o[0] < g2[0] ? -1 : 1));
}
var f = { mergeType: 1, progressFn: null, joinRangesThatTouchEdges: true };
function y(i, r) {
  function t(s) {
    return !!s && typeof s == "object" && !Array.isArray(s);
  }
  if (!Array.isArray(i) || !i.length)
    return null;
  let e;
  if (r)
    if (t(r)) {
      if (e = { ...f, ...r }, e.progressFn && t(e.progressFn) && !Object.keys(e.progressFn).length)
        e.progressFn = null;
      else if (e.progressFn && typeof e.progressFn != "function")
        throw new Error(`ranges-merge: [THROW_ID_01] resolvedOpts.progressFn must be a function! It was given of a type: "${typeof e.progressFn}", equal to ${JSON.stringify(e.progressFn, null, 4)}`);
      if (![1, 2, "1", "2"].includes(e.mergeType))
        throw new Error(`ranges-merge: [THROW_ID_02] resolvedOpts.mergeType was customised to a wrong thing! It was given of a type: "${typeof e.mergeType}", equal to ${JSON.stringify(e.mergeType, null, 4)}`);
      if (typeof e.joinRangesThatTouchEdges != "boolean")
        throw new Error(`ranges-merge: [THROW_ID_04] resolvedOpts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof e.joinRangesThatTouchEdges}", equal to ${JSON.stringify(e.joinRangesThatTouchEdges, null, 4)}`);
    } else
      throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r, null, 4)} (type ${typeof r})`);
  else
    e = { ...f };
  let a = i.filter((s) => Array.isArray(s)).map((s) => [...s]).filter((s) => s[2] !== void 0 || s[0] !== s[1]), n, l, o;
  e.progressFn ? n = h(a, { progressFn: (s) => {
    o = Math.floor(s / 5), o !== l && (l = o, e.progressFn(o));
  } }) : n = h(a);
  let g2 = n.length - 1;
  for (let s = g2; s > 0; s--)
    e.progressFn && (o = Math.floor((1 - s / g2) * 78) + 21, o !== l && o > l && (l = o, e.progressFn(o))), (n[s][0] <= n[s - 1][0] || !e.joinRangesThatTouchEdges && n[s][0] < n[s - 1][1] || e.joinRangesThatTouchEdges && n[s][0] <= n[s - 1][1]) && (n[s - 1][0] = Math.min(n[s][0], n[s - 1][0]), n[s - 1][1] = Math.max(n[s][1], n[s - 1][1]), n[s][2] !== void 0 && (n[s - 1][0] >= n[s][0] || n[s - 1][1] <= n[s][1]) && n[s - 1][2] !== null && (n[s][2] === null && n[s - 1][2] !== null ? n[s - 1][2] = null : n[s - 1][2] != null ? +e.mergeType == 2 && n[s - 1][0] === n[s][0] ? n[s - 1][2] = n[s][2] : n[s - 1][2] += n[s][2] : n[s - 1][2] = n[s][2]), n.splice(s, 1), s = n.length);
  return n.length ? n : null;
}
function u(i) {
  return i != null;
}
function p(i) {
  return Number.isInteger(i) && i >= 0;
}
function m(i) {
  return typeof i == "string";
}
var T = { limitToBeAddedWhitespace: false, limitLinebreaksCount: 1, mergeType: 1 };
var $ = class {
  constructor(r) {
    let t = { ...T, ...r };
    if (t.mergeType && t.mergeType !== 1 && t.mergeType !== 2)
      if (m(t.mergeType) && t.mergeType.trim() === "1")
        t.mergeType = 1;
      else if (m(t.mergeType) && t.mergeType.trim() === "2")
        t.mergeType = 2;
      else
        throw new Error(`ranges-push: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof t.mergeType}", equal to ${JSON.stringify(t.mergeType, null, 4)}`);
    this.opts = t, this.ranges = [];
  }
  ranges;
  opts;
  add(r, t, e) {
    if (r == null && t == null)
      return;
    if (u(r) && !u(t)) {
      if (Array.isArray(r)) {
        if (r.length) {
          if (r.some((l) => Array.isArray(l))) {
            r.forEach((l) => {
              Array.isArray(l) && this.add(...l);
            });
            return;
          }
          r.length && p(+r[0]) && p(+r[1]) && this.add(...r);
        }
        return;
      }
      throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_12] the first input argument, "from" is set (${JSON.stringify(r, null, 0)}) but second-one, "to" is not (${JSON.stringify(t, null, 0)})`);
    } else if (!u(r) && u(t))
      throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_13] the second input argument, "to" is set (${JSON.stringify(t, null, 0)}) but first-one, "from" is not (${JSON.stringify(r, null, 0)})`);
    let a = +r, n = +t;
    if (p(e) && (e = String(e)), p(a) && p(n)) {
      if (u(e) && !m(e) && !p(e))
        throw new TypeError(`ranges-push/Ranges/add(): [THROW_ID_08] The third argument, the value to add, was given not as string but ${typeof e}, equal to:
${JSON.stringify(e, null, 4)}`);
      if (u(this.ranges) && Array.isArray(this.last()) && a === this.last()[1]) {
        if (this.last()[1] = n, this.last()[2], this.last()[2] !== null && u(e)) {
          let l = this.last()[2] && this.last()[2].length && (!this.opts?.mergeType || this.opts.mergeType === 1) ? `${this.last()[2]}${e}` : e;
          this.opts.limitToBeAddedWhitespace && (l = D(l, this.opts.limitLinebreaksCount)), m(l) && !l.length || (this.last()[2] = l);
        }
      } else {
        this.ranges || (this.ranges = []);
        let l = e !== void 0 && !(m(e) && !e.length) ? [a, n, e && this.opts.limitToBeAddedWhitespace ? D(e, this.opts.limitLinebreaksCount) : e] : [a, n];
        this.ranges.push(l);
      }
    } else
      throw p(a) && a >= 0 ? new TypeError(`ranges-push/Ranges/add(): [THROW_ID_10] "to" value, the second input argument, must be a natural number or zero! Currently it's of a type "${typeof n}" equal to: ${JSON.stringify(n, null, 4)}`) : new TypeError(`ranges-push/Ranges/add(): [THROW_ID_09] "from" value, the first input argument, must be a natural number or zero! Currently it's of a type "${typeof a}" equal to: ${JSON.stringify(a, null, 4)}`);
  }
  push(r, t, e) {
    this.add(r, t, e);
  }
  current() {
    return Array.isArray(this.ranges) && this.ranges.length ? (this.ranges = y(this.ranges, { mergeType: this.opts.mergeType }), this.ranges && this.opts.limitToBeAddedWhitespace ? this.ranges.map((r) => u(r[2]) ? [r[0], r[1], D(r[2], this.opts.limitLinebreaksCount)] : r) : this.ranges) : null;
  }
  wipe() {
    this.ranges = [];
  }
  replace(r) {
    if (Array.isArray(r) && r.length)
      if (Array.isArray(r[0]) && p(r[0][0]))
        this.ranges = Array.from(r);
      else
        throw new Error(`ranges-push/Ranges/replace(): [THROW_ID_11] Single range was given but we expected array of arrays! The first element, ${JSON.stringify(r[0], null, 4)} should be an array and its first element should be an integer, a string index.`);
    else
      this.ranges = [];
  }
  last() {
    return Array.isArray(this.ranges) && this.ranges.length ? this.ranges[this.ranges.length - 1] : null;
  }
};
// ../ranges-sort/dist/ranges-sort.esm.js
var d = { strictlyTwoElementsInRangeArrays: false, progressFn: null };
function g(t, u2) {
  if (!Array.isArray(t) || !t.length)
    return t;
  let n = { ...d, ...u2 }, s, o;
  if (n.strictlyTwoElementsInRangeArrays && !t.every((e, r) => !Array.isArray(e) || e.length !== 2 ? (s = r, o = e.length, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_03] The first argument should be an array and must consist of arrays which are natural number indexes representing TWO string index ranges. However, ${s}th range (${JSON.stringify(t[s], null, 4)}) has not two but ${o} elements!`);
  if (!t.every((e, r) => !Array.isArray(e) || !Number.isInteger(e[0]) || e[0] < 0 || !Number.isInteger(e[1]) || e[1] < 0 ? (s = r, false) : true))
    throw new TypeError(`ranges-sort: [THROW_ID_04] The first argument should be an array and must consist of arrays which are natural number indexes representing string index ranges. However, ${s}th range (${JSON.stringify(t[s], null, 4)}) does not consist of only natural numbers!`);
  let p2 = t.length ** 2, i = 0;
  return Array.from(t).sort((e, r) => (n.progressFn && (i += 1, n.progressFn(Math.floor(i * 100 / p2))), e[0] === r[0] ? e[1] < r[1] ? -1 : e[1] > r[1] ? 1 : 0 : e[0] < r[0] ? -1 : 1));
}
// ../ranges-merge/dist/ranges-merge.esm.js
var d2 = { mergeType: 1, progressFn: null, joinRangesThatTouchEdges: true };
function b2(i, r) {
  function l(e) {
    return !!e && typeof e == "object" && !Array.isArray(e);
  }
  if (!Array.isArray(i) || !i.length)
    return null;
  let n;
  if (r)
    if (l(r)) {
      if (n = { ...d2, ...r }, n.progressFn && l(n.progressFn) && !Object.keys(n.progressFn).length)
        n.progressFn = null;
      else if (n.progressFn && typeof n.progressFn != "function")
        throw new Error(`ranges-merge: [THROW_ID_01] opts.progressFn must be a function! It was given of a type: "${typeof n.progressFn}", equal to ${JSON.stringify(n.progressFn, null, 4)}`);
      if (![1, 2, "1", "2"].includes(n.mergeType))
        throw new Error(`ranges-merge: [THROW_ID_02] opts.mergeType was customised to a wrong thing! It was given of a type: "${typeof n.mergeType}", equal to ${JSON.stringify(n.mergeType, null, 4)}`);
      if (typeof n.joinRangesThatTouchEdges != "boolean")
        throw new Error(`ranges-merge: [THROW_ID_04] opts.joinRangesThatTouchEdges was customised to a wrong thing! It was given of a type: "${typeof n.joinRangesThatTouchEdges}", equal to ${JSON.stringify(n.joinRangesThatTouchEdges, null, 4)}`);
    } else
      throw new Error(`emlint: [THROW_ID_03] the second input argument must be a plain object. It was given as:
${JSON.stringify(r, null, 4)} (type ${typeof r})`);
  else
    n = { ...d2 };
  let g2 = i.filter((e) => Array.isArray(e)).map((e) => [...e]).filter((e) => e[2] !== void 0 || e[0] !== e[1]), s, o, t;
  n.progressFn ? s = g(g2, { progressFn: (e) => {
    t = Math.floor(e / 5), t !== o && (o = t, n.progressFn(t));
  } }) : s = g(g2);
  let a = s.length - 1;
  for (let e = a; e > 0; e--)
    n.progressFn && (t = Math.floor((1 - e / a) * 78) + 21, t !== o && t > o && (o = t, n.progressFn(t))), (s[e][0] <= s[e - 1][0] || !n.joinRangesThatTouchEdges && s[e][0] < s[e - 1][1] || n.joinRangesThatTouchEdges && s[e][0] <= s[e - 1][1]) && (s[e - 1][0] = Math.min(s[e][0], s[e - 1][0]), s[e - 1][1] = Math.max(s[e][1], s[e - 1][1]), s[e][2] !== void 0 && (s[e - 1][0] >= s[e][0] || s[e - 1][1] <= s[e][1]) && s[e - 1][2] !== null && (s[e][2] === null && s[e - 1][2] !== null ? s[e - 1][2] = null : s[e - 1][2] != null ? +n.mergeType == 2 && s[e - 1][0] === s[e][0] ? s[e - 1][2] = s[e][2] : s[e - 1][2] += s[e][2] : s[e - 1][2] = s[e][2]), s.splice(e, 1), e = s.length);
  return s.length ? s : null;
}
// ../../node_modules/tiny-invariant/dist/esm/tiny-invariant.js
var isProduction = process.env.NODE_ENV === "production";
var prefix = "Invariant failed";
function invariant(condition, message) {
  if (condition) {
    return;
  }
  if (isProduction) {
    throw new Error(prefix);
  }
  var provided = typeof message === "function" ? message() : message;
  var value = provided ? "".concat(prefix, ": ").concat(provided) : prefix;
  throw new Error(value);
}
// ../ranges-apply/dist/ranges-apply.esm.js
function _(s, n, r) {
  let t = 0, p2 = 0;
  if (arguments.length === 0)
    throw new Error("ranges-apply: [THROW_ID_01] inputs missing!");
  if (typeof s != "string")
    throw new TypeError(`ranges-apply: [THROW_ID_02] first input argument must be a string! Currently it's: ${typeof s}, equal to: ${JSON.stringify(s, null, 4)}`);
  if (n && !Array.isArray(n))
    throw new TypeError(`ranges-apply: [THROW_ID_03] second input argument must be an array (or null)! Currently it's: ${typeof n}, equal to: ${JSON.stringify(n, null, 4)}`);
  if (r && typeof r != "function")
    throw new TypeError(`ranges-apply: [THROW_ID_04] the third input argument must be a function (or falsey)! Currently it's: ${typeof r}, equal to: ${JSON.stringify(r, null, 4)}`);
  if (!n || !n.filter((e) => e).length)
    return s;
  let i;
  Array.isArray(n) && Number.isInteger(n[0]) && Number.isInteger(n[1]) ? i = [Array.from(n)] : i = Array.from(n);
  let f2 = i.length, c = 0;
  i.filter((e) => e).forEach((e, a) => {
    if (r && (t = Math.floor(c / f2 * 10), t !== p2 && (p2 = t, r(t))), !Array.isArray(e))
      throw new TypeError(`ranges-apply: [THROW_ID_05] ranges array, second input arg., has ${a}th element not an array: ${JSON.stringify(e, null, 4)}, which is ${typeof e}`);
    if (!Number.isInteger(e[0])) {
      if (!Number.isInteger(+e[0]) || +e[0] < 0)
        throw new TypeError(`ranges-apply: [THROW_ID_06] ranges array, second input arg. has ${a}th element, array ${JSON.stringify(e, null, 0)}. Its first element is not an integer, string index, but ${typeof e[0]}, equal to: ${JSON.stringify(e[0], null, 4)}.`);
      i[a][0] = +i[a][0];
    }
    if (!Number.isInteger(e[1])) {
      if (!Number.isInteger(+e[1]) || +e[1] < 0)
        throw new TypeError(`ranges-apply: [THROW_ID_07] ranges array, second input arg. has ${a}th element, array ${JSON.stringify(e, null, 0)}. Its second element is not an integer, string index, but ${typeof e[1]}, equal to: ${JSON.stringify(e[1], null, 4)}.`);
      i[a][1] = +i[a][1];
    }
    c += 1;
  });
  let o = b2(i, { progressFn: (e) => {
    r && (t = 10 + Math.floor(e / 10), t !== p2 && (p2 = t, r(t)));
  } });
  invariant(o);
  let u2 = o.length;
  if (u2 > 0) {
    let e = s.slice(o[u2 - 1][1]);
    s = o.reduce((a, $2, l, y2) => {
      r && (t = 20 + Math.floor(l / u2 * 80), t !== p2 && (p2 = t, r(t)));
      let g2 = l === 0 ? 0 : y2[l - 1][1], d3 = y2[l][0];
      return `${a}${s.slice(g2, d3)}${y2[l][2] || ""}`;
    }, ""), s += e;
  }
  return s;
}
// ../js-row-num/dist/js-row-num.esm.js
var v = { padStart: 3, overrideRowNum: null, triggerKeywords: ["console.log"], extractedLogContentsWereGiven: false };
function j(t, S) {
  let p2 = Date.now(), f2 = "\\";
  if (typeof t != "string")
    throw new TypeError(`js-row-num: [THROW_ID_01] Input must be string! Currently it's: ${(typeof t).toLowerCase()}, equal to:
${JSON.stringify(t, null, 4)}`);
  if (!t.trim())
    return { log: { timeTakenInMilliseconds: Date.now() - p2 }, result: t, ranges: null };
  function m2(n) {
    return /[0-9]/.test(n);
  }
  function D2(n) {
    return /[A-Za-z]/.test(n);
  }
  function w(n) {
    return !!n && typeof n == "object" && !Array.isArray(n);
  }
  let o = { ...v, ...S };
  if (Object.prototype.hasOwnProperty.call(o, "returnRangesOnly"))
    throw new TypeError(`js-row-num: [THROW_ID_02] The Optional Options Object's key "returnRangesOnly" has been removed from the API since v.6 release.`);
  (!o.padStart || typeof o.padStart != "number" || typeof o.padStart == "number" && o.padStart < 0) && (o.padStart = 0);
  let g2 = new $(), e, d3 = t.length, r = null, u2 = null, a = null, c = 1, $2 = false, s = null;
  for (o.padStart && d3 > 45e3 && (o.padStart = 4), e = 0; e < d3; e++) {
    if (o.overrideRowNum === null && (t[e] === `
` || t[e] === "\r" && t[e + 1] !== `
`) && (c += 1), !o.extractedLogContentsWereGiven && r !== null && r.start < e && r.type === t[e] && (r = null, u2 = null, a = null, s = null, $2 = false), r === null && (o.extractedLogContentsWereGiven || u2 && u2 < e && a && a < e) && t[e].trim())
      if (t[e] === '"' || t[e] === "'" || t[e] === "`")
        r = { start: e, type: t[e] }, $2 = false;
      else if (o.extractedLogContentsWereGiven && s === null)
        if (m2(t[e]))
          s = e;
        else
          break;
      else
        t[e].trim() && t[e] !== "/" && !o.extractedLogContentsWereGiven && (u2 = null, a = null, s = null);
    if (r && Number.isInteger(r.start) && r.start < e && !$2 && s === null && m2(t[e]) && (s = e), Number.isInteger(s) && (!m2(t[e]) || !t[e + 1]) && (e > s || !t[e + 1]) && (o.padStart || o.overrideRowNum != null, g2.push(s, m2(t[e]) ? e + 1 : e, o.padStart ? String(o.overrideRowNum != null ? o.overrideRowNum : c).padStart(o.padStart, "0") : `${o.overrideRowNum != null ? o.overrideRowNum : c}`), s = null, $2 = true), r && Number.isInteger(r.start) && r.start < e && !$2 && D2(t[e]) && !(t[e] === "n" && t[e - 1] === f2)) {
      if (t[e - 1] === f2 && t[e] === "u" && t[e + 1] === "0" && t[e + 2] === "0" && t[e + 3] === "1" && (t[e + 4] === "b" || t[e + 5] === "B") && t[e + 5] === "[") {
        let n;
        m2(t[e + 6]) ? n = e + 6 : t[e + 6] === "$" && t[e + 7] === "{" && m2(t[e + 8]) && (n = e + 8);
        let l;
        if (n) {
          for (let b3 = n; b3 < d3; b3++)
            if (!m2(t[b3])) {
              l = b3;
              break;
            }
        }
        let i;
        if (l !== void 0 && t[l] === "m" ? i = l : l !== void 0 && t[l] === "}" && t[l + 1] === "m" && (i = l + 1), !i) {
          $2 = true;
          continue;
        }
        if (t[i + 1] === "$" && t[i + 2] === "{" && t[i + 3] === "`") {
          e = i + 3;
          continue;
        }
      }
      $2 = true;
    }
    if (!a && t[e].trim() && u2 && u2 <= e && (t[e] === "(" ? a = e : (u2 = null, s = null)), w(o) && o.triggerKeywords && Array.isArray(o.triggerKeywords)) {
      let n;
      for (let l = 0, i = o.triggerKeywords.length; l < i; l++)
        if (t.startsWith(o.triggerKeywords[l], e)) {
          n = o.triggerKeywords[l];
          break;
        }
      if (n) {
        u2 = e + n.length, e = e + n.length - 1;
        continue;
      }
    }
  }
  return r = null, u2 = null, a = null, c = 1, $2 = void 0, s = null, c = 1, { log: { timeTakenInMilliseconds: Date.now() - p2 }, result: _(t, g2.current()), ranges: g2.current() };
}
// src/correct-row-num.ts
var create = (context) => {
  return {
    CallExpression(node) {
      if (node.callee && node.callee.type === "MemberExpression" && node.callee.object && node.callee.object.type === "Identifier" && node.callee.object.name === "console" && node.callee.property && node.callee.property.type === "Identifier" && node.callee.property.name === "log" && node.arguments && Array.isArray(node.arguments) && node.arguments.length) {
        node.arguments.forEach((arg) => {
          if (arg.type === "Literal" && typeof arg.raw === "string" && arg.raw !== j(arg.raw, {
            overrideRowNum: arg.loc.start.line,
            extractedLogContentsWereGiven: true
          }).result) {
            context.report({
              node,
              messageId: "correctRowNum",
              fix: (fixerObj) => {
                let { ranges } = j(arg.raw, {
                  overrideRowNum: arg.loc.start.line,
                  extractedLogContentsWereGiven: true
                });
                if (Array.isArray(ranges) && ranges.length) {
                  let offset = arg.start;
                  if (!offset && arg.range && typeof arg.range[0] === "number") {
                    offset = arg.range[0];
                  }
                  let preppedRanges = [
                    offset + ranges[0][0],
                    offset + ranges[0][1]
                  ];
                  return fixerObj.replaceTextRange(preppedRanges, ranges[0][2]);
                }
              }
            });
          } else if (arg.type === "TemplateLiteral" && Array.isArray(arg.quasis) && arg.quasis.length && typeof arg.quasis[0] === "object" && arg.quasis[0].value && arg.quasis[0].value.raw && arg.quasis[0].value.raw !== j(arg.quasis[0].value.raw, {
            overrideRowNum: arg.loc.start.line,
            extractedLogContentsWereGiven: true
          }).result) {
            context.report({
              node,
              messageId: "correctRowNum",
              fix: (fixerObj) => {
                let { ranges } = j(arg.quasis[0].value.raw, {
                  overrideRowNum: arg.loc.start.line,
                  extractedLogContentsWereGiven: true
                });
                if (ranges) {
                  let offset = arg.quasis[0].range[0] + 1;
                  if (!offset && arg.range && typeof arg.range[0] === "number") {
                    offset = arg.quasis[0].start + 1;
                  }
                  let preppedRanges = [
                    offset + ranges[0][0],
                    offset + ranges[0][1]
                  ];
                  return fixerObj.replaceTextRange(preppedRanges, ranges[0][2]);
                }
              }
            });
          }
        });
      }
    }
  };
};
var correctRowNum = {
  create,
  meta: {
    type: "suggestion",
    messages: {
      correctRowNum: "Update the row number."
    },
    fixable: "code"
  }
};
// src/main.ts
var main_default = {
  configs: {
    recommended: {
      plugins: ["row-num"],
      rules: {
        "no-console": "off",
        "row-num/correct-row-num": "error"
      }
    }
  },
  rules: {
    "correct-row-num": correctRowNum
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
/**
 * @name js-row-num
 * @fileoverview Update all row numbers in all console.logs in JS code
 * @version 7.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/js-row-num/}
 */
/**
 * @name ranges-apply
 * @fileoverview Take an array of string index ranges, delete/replace the string according to them
 * @version 7.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-apply/}
 */
/**
 * @name ranges-merge
 * @fileoverview Merge and sort string index ranges
 * @version 9.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-merge/}
 */
/**
 * @name ranges-push
 * @fileoverview Gather string index ranges
 * @version 7.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-push/}
 */
/**
 * @name ranges-sort
 * @fileoverview Sort string index ranges
 * @version 6.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/ranges-sort/}
 */
/**
 * @name string-collapse-leading-whitespace
 * @fileoverview Collapse the leading and trailing whitespace of a string
 * @version 7.0.2
 * @author Roy Revelt, Codsen Ltd
 * @license MIT
 * {@link https://codsen.com/os/string-collapse-leading-whitespace/}
 */

module.exports = main_default;
